MrSID Decode SDK for Raster Reference Manual 9.5.4.4709

- Main Page
- Namespaces
- Classes
- Files
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
LTIRawImageReader Class Reference

class for reading RAW files More...

`#include <lti_rawImageReader.h>`

Inheritance diagram for LTIRawImageReader:
[legend]
Collaboration diagram for LTIRawImageReader:
[legend]

## Public Member Functions
LT_STATUS | initialize (LTIOStreamInf *stream, const LTIPixel &pixelProps, lt_uint32 width, lt_uint32 height, bool useWorldFile=true)
| initialize (stream) More...
LT_STATUS | initialize (const LTFileSpec &fileSpec, const LTIPixel &pixelProps, lt_uint32 width, lt_uint32 height, bool useWorldFile=true)
| initialize (FileSpec) More...
LT_STATUS | initialize (const char *file, const LTIPixel &pixelProps, lt_uint32 width, lt_uint32 height, bool useWorldFile=true)
| initialize (char*) More...
Properties of the RAW image
These must be called prior to calling initialize(), unlike most other SDK objects.
void | setStreamOwnership (bool takeOwnership)
| set stream ownership More...
void | setRowBytes (lt_uint32 rowBytes)
| sets the number of bytes in each row More...
void | setLayout (LTILayout layout)
| sets the layout or organization of the raw data More...
void | setSkipBytes (lt_int64 leadingBytes, lt_int64 trailingBytes=0)
| sets the number of bytes to skip at the beginning and end of the file More...
void | setByteOrder (LTIEndian byteOrder)
| sets endianness of input file More...

## Static Public Member Functions
static LTIRawImageReader * | create (void)

## Protected Member Functions
| LTIRawImageReader (void)
virtual | ~LTIRawImageReader (void)
LT_STATUS | decodeBegin (const LTIPixel &pixelProps, const LTIScene &fullScene)
| start strip-based read More...
LT_STATUS | decodeStrip (LTISceneBuffer &stripBuffer, const LTIScene &stripScene)
| read a strip from the image More...
LT_STATUS | decodeEnd (void)
| finish strip-based read More...
const char * | getSourceName (void) const
Protected Member Functions inherited from LTIGeoImageReader
| LTIGeoImageReader (bool supportBandSelection)
LT_STATUS | init (bool useWorldFile)
bool | getUseWorldFile () const
LT_STATUS | readWorldFile (const LTFileSpec &file, bool &changed, bool doUseWorldFileTest=true)
LT_STATUS | readWorldFile (LTIOStreamInf &stream, bool &changed, bool doUseWorldFileTest=true)
Protected Member Functions inherited from LTIImageReader
| LTIImageReader (bool supportBandSelection)
LT_STATUS | init (const LTIImage *image=NULL)
LT_STATUS | loadMetadataIntoObjects (const LTIMetadataDatabase &fileMetadata, LTIPixel &pixelProps, bool updatePixelProps, bool updateGeoCoord)

## Protected Attributes
LTFileSpec * | m_fileSpec

## Detailed Description

This class reads a RAW image.

The RAW format used is simple packed BIP form.

Examples:
  Pipeline.cpp.

Definition at line 30 of file lti_rawImageReader.h.

## Constructor & Destructor Documentation

LTIRawImageReader::LTIRawImageReader | ( | void | ) |  |
| protected

virtual LTIRawImageReader::~LTIRawImageReader | ( | void | ) |  |
| protected virtual

## Member Function Documentation

static LTIRawImageReader* LTIRawImageReader::create | ( | void | ) |  |
| static

Examples:
  Pipeline.cpp.

LT_STATUS LTIRawImageReader::decodeBegin | ( | const LTIPixel & | pixelProps,
|  | const LTIScene & | fullScene
| ) |  |
| protected virtual

This function is called by readBegin() to start the actual class-specific work for decoding a scene.

Derived classes must implement this function.

This function should never be called directly.

Parameters

  pixelProps | the band selection
  fullScene | the full scene to be read

Returns
  status code indicating success or failure

Implements LTIImageStage.

LT_STATUS LTIRawImageReader::decodeEnd | ( | void | ) |  |
| protected virtual

This function is called by readEnd() to complete the actual class-specific work for decoding a scene.

Derived classes must implement this function.

This function should never be called directly.

Returns
  status code indicating success or failure

Implements LTIImageStage.

LT_STATUS LTIRawImageReader::decodeStrip | ( | LTISceneBuffer & | stripBuffer,
|  | const LTIScene & | stripScene
| ) |  |
| protected virtual

This function is called by readStrip() to implement the actual class-specific work for decoding a strip of the scene.

Derived classes must implement this function.

This function should never be called directly.

Parameters

  stripBuffer | the buffer to read the pixels into
  stripScene | the scene for this strip being decoded

Returns
  status code indicating success or failure

Implements LTIImageStage.

const char* LTIRawImageReader::getSourceName | ( | void | ) |  | const
| protected virtual

Implements LTIImageReader.

LT_STATUS LTIRawImageReader::initialize | ( | LTIOStreamInf * | stream,
|  | const LTIPixel & | pixelProps,
|  | lt_uint32 | width,
|  | lt_uint32 | height,
|  | bool | useWorldFile = `true`
| ) |  |

This function constructs an LTIImageReader using the data in the stream with the image properties specified. The input taken from a stream.

Parameters

  stream | stream containing the RAW image data (may not be NULL)
  pixelProps | the pixel properties of the image (colorspace, datatype, etc)
  width | the width of the image
  height | the height of the image
  useWorldFile | use world file information if available

Examples:
  Pipeline.cpp.

LT_STATUS LTIRawImageReader::initialize | ( | const LTFileSpec & | fileSpec,
|  | const LTIPixel & | pixelProps,
|  | lt_uint32 | width,
|  | lt_uint32 | height,
|  | bool | useWorldFile = `true`
| ) |  |

This function constructs an LTIImageReader using the data in the stream with the image properties specified. The input taken from a stream, and the background and nodata pixels may be specified.

Parameters

  fileSpec | file containing the RAW image data
  pixelProps | the pixel properties of the image (colorspace, datatype, etc)
  width | the width of the image
  height | the height of the image
  useWorldFile | use world file information if available

LT_STATUS LTIRawImageReader::initialize | ( | const char * | file,
|  | const LTIPixel & | pixelProps,
|  | lt_uint32 | width,
|  | lt_uint32 | height,
|  | bool | useWorldFile = `true`
| ) |  |

This function constructs an LTIImageReader using the data in the stream with the image properties specified. The input taken from a stream, and the background and nodata pixels may be specified.

Parameters

  file | file containing the RAW image data (may not be NULL)
  pixelProps | the pixel properties of the image (colorspace, datatype, etc)
  width | the width of the image
  height | the height of the image
  useWorldFile | use world file information if available

void LTIRawImageReader::setByteOrder | ( | LTIEndian | byteOrder) |  |

Sets the byte order or endianness of the input file.

Note
  This must be called prior to calling initialize().

Parameters

  byteOrder | the endian setting to use

void LTIRawImageReader::setLayout | ( | LTILayout | layout) |  |

Sets the layout or organization of the raw data.

If not set, the default is BIP format.

Note
  This must be called prior to calling initialize().

Parameters

  layout | the layout of the raw data

void LTIRawImageReader::setRowBytes | ( | lt_uint32 | rowBytes) |  |

Sets the number of bytes in each row.

If not set, the bytes per row is simply the number of data items per row times the size of a data item. (Note that a "data item" in this case may be either a pixel or a sample, depending on the layout being used.)

Note
  This must be called prior to calling initialize().

Parameters

  rowBytes | the number of bytes per row

void LTIRawImageReader::setSkipBytes | ( | lt_int64 | leadingBytes,
|  | lt_int64 | trailingBytes = `0`
| ) |  |

Sets the number of bytes to skip at the beginning of the file and the end of the file. (The "ending skip bytes" property is sometimes required because LTIRawImageReader::initialize() does a sanity check to make sure the number of data bytes in the file is equal to the number of bytes needed for the given width, height, etc.

Note
  This must be called prior to calling initialize().

Parameters

  leadingBytes | the number of bytes to skip at the top
  trailingBytes | the number of bytes to skip at the bottom

void LTIRawImageReader::setStreamOwnership | ( | bool | takeOwnership) |  |

Sets the ownership of the stream, to indicate responsibility for deleting the stream when done. This only pertains to objects which were passed a stream in the ctor.

If not set, the default is for the object to not take ownership of the stream.

Note
  This must be called prior to calling initialize().

Parameters

  takeOwnership | set to true to have the reader delete the stream

## Member Data Documentation

LTFileSpec* LTIRawImageReader::m_fileSpec
| protected

Definition at line 184 of file lti_rawImageReader.h.

The documentation for this class was generated from the following file:

- lti_rawImageReader.h

LizardTech